<template>
  <div class="col-md-10 pt-4">
    <lenna-modal ref="lennaModal"></lenna-modal>

    <form class="form-material" @submit.prevent="submitForm">
      <h4>Broadcast Message</h4>
      <div class="form-group">
        <label>Select Channel</label>
        <select class="form-control" v-model="form.selectedChannel">
          <!-- <option value="all">All Channel</option> -->
          <option
            v-for="channel in channelList"
            :value="channel.name"
            :key="channel.id"
          >{{channel.name}}</option>
        </select>
      </div>
      <div class="form-group">
        <label>Send To</label>
        <select class="form-control" v-model="form.broadcastType">
          <option value="global">All User</option>
          <option value="single">Single User</option>
        </select>
      </div>
      <div class="form-group" v-show="form.broadcastType == 'single'">
        <label>Select User</label>

        <multiselect
          v-model="selectedUser"
          :options="userList"
          :close-on-select="true"
          :clear-on-select="false"
          placeholder="Select user"
          label="email"
          track-by="name"
          :preselect-first="true"
          @search-change="selectSearchHandler"
        >
          <template slot="selection" slot-scope="{ values, search, isOpen }">
            <span class v-if="values.length &amp;&amp; !isOpen">{{ values.length }} User selected</span>
          </template>
        </multiselect>
      </div>

      <strong class="d-block mt-2">Notification</strong>
      <div class="row">
        <div class="form-group col-md-6">
          <label>Notification Title</label>
          <input
            type="text"
            v-validate="'required'"
            name="notificationTitle"
            v-model="form.notificationTitle"
            class="form-control"
          >
          <small class="text-danger">{{ errors.first('notificationTitle') }}</small>
        </div>

        <div class="form-group col-md-6">
          <label>Notification Body</label>
          <input
            type="text"
            v-validate="'required'"
            name="notification body"
            v-model="form.notificationBody"
            class="form-control"
          >
          <small class="text-danger">{{ errors.first('notification body') }}</small>
        </div>
      </div>

      <strong class="d-block mt-2">Message</strong>

      <div class="form-group">
        <label>Message Title</label>
        <input
          type="text"
          v-model="form.messageTitle"
          class="form-control"
          v-validate="'required'"
          name="message title"
        >
        <small class="text-danger">{{ errors.first('message title') }}</small>
      </div>
      <div class="form-group" v-show="form.selectedChannel == 'mobile'">
        <label>Message Body</label>
        <rich-editor v-model="form.messageBody"></rich-editor>
      </div>
      <div class="form-group" v-show="form.selectedChannel != 'mobile'">
        <label>Message Body</label>
        <textarea class="form-control" v-model="form.messageBody" name="message body"></textarea>
      </div>
      <button type="submit" class="btn btn-primary form-control capsule">
        <span v-if="loading">
          Sending
          <i class="fas fa-circle-notch fa-spin"></i>
        </span>
        <span v-else>Send</span>
      </button>
    </form>
  </div>
</template>

<script>
import Multiselect from "vue-multiselect";
import RichEditor from "@/components/general/RichEditor";
import FormError from "@/components/general/FormError";

export default {
  data() {
    return {
      channelList: null,
      userList: [],
      allUser: [],
      selectedUser: null,
      form: {
        selectedChannel: "mobile",
        broadcastType: "global",
        broadcastCategory: "broadcast",
        messageBody: "",
        messageTitle: "",
        notificationBody: "",
        notificationTitle: ""
      },
      formErrors: {},
      loading: false
    };
  },
  computed: {
    selectedChannel() {
      return this.form.selectedChannel;
    }
  },
  components: {
    FormError,
    Multiselect,
    RichEditor
  },
  created() {
    this.getChannel();
    // this.getUser();
  },
  methods: {
    selectSearchHandler(query) {
      this.getUser({ filter: query });
    },
    getChannel() {
      axios.get(this.$store.state.appUrl + "/api/channel").then(response => {
        return (this.channelList = response.data);
      });
    },
    getUser(query = {}) {
      this.$axios
        .get(`api/${this.$store.getters.appId.hashed}/user/get-user-list`, {
          params: {
            channel: this.selectedChannel,
            ...query
          }
        })
        .then(response => {
          this.userList = response.data;
        });
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          let response = await this.$axios.post(
            `api/${this.$store.getters.appId.hashed}/broadcast/send`,
            {
              ...this.form,
              userId: this.selectedUser ? this.selectedUser.id : null
            }
          );
          this.$notify({
            group: "notif",
            type: "info",
            title: "Info",
            text: response.data.message
          });
        } catch (error) {
          this.formErrors = error.response.data.errors;
          this.$notify({
            group: "error",
            type: "error",
            title: "Error",
            text: error.response.data.message
          });
        }
      } else {
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          "You must correct your form first"
        );
      }
    }
  },
  watch: {
    selectedChannel() {
      this.form.messageBody = "";
    }
  }
};
</script>
<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>
<style lang="scss" >
.multiselect {
  font-size: 0.8em;
}
.multiselect__tags {
  background: #f5f5f5 !important;
  & input {
    background: #f5f5f5 !important;
  }
}
.multiselect__select {
  width: auto;
  padding: 4px 2px;
}

.multiselect__option--selected.multiselect__option--highlight {
  background: #fbfbfb;
  color: #5d5d5d;
  padding-left: 10px;
}
.multiselect__option--highlight {
  background: #fbfbfb;
  color: #5d5d5d;
  padding-left: 10px;
}
.multiselect__option--group {
  & span {
    text-transform: uppercase;
  }
  background: #b6b6b6;
  color: white;
}
.multiselect__option--group-selected {
  background: #d3d3d3;
  color: #5d5d5d;
}
.multiselect__content-wrapper {
  border: 1px solid #cecece;
}
.multiselect__single {
  background: #f5f5f5;
}
</style>

